package xyz.brassgoggledcoders.boilerplate.lib.common.items.tools;

import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.BlockPos;
import net.minecraft.world.World;

import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import xyz.brassgoggledcoders.boilerplate.lib.common.items.BaseItem;
import xyz.brassgoggledcoders.boilerplate.lib.common.utils.ItemStackUtils;
import xyz.brassgoggledcoders.boilerplate.lib.common.utils.helpers.MaterialHelper;

import net.minecraft.item.Item.ToolMaterial;
/**
 * @author Surseance
 *
 */
public abstract class BaseTool extends BaseItem
{
	// TODO: Rendering stuff

	public static final int steamForRepair = 20;
	public float efficiencyOnProperMaterial = 4.0F;
	public float damageVsEntity;
	protected ToolMaterial toolMaterial;

	protected BaseTool(float damage, ToolMaterial toolMat)
	{
		super("tools/");
		this.toolMaterial = toolMat;
		this.func_77625_d(1);
		this.efficiencyOnProperMaterial = toolMat.func_77998_b();
		this.damageVsEntity = damage + toolMat.func_78000_c();
		this.func_77664_n();
		this.func_77656_e(toolMat.func_77997_a());
	}

	@SuppressWarnings("all")
	@Override
	@SideOnly(Side.CLIENT)
	public void func_150895_a(Item item, CreativeTabs tab, List l)
	{
		l.add(new ItemStack(item, 1));
	}

	@Override
	public float getDigSpeed(ItemStack stack, IBlockState state)
	{
		Block block = state.func_177230_c();
		if (block.getHarvestLevel(state) <= this.toolMaterial.func_77996_d())
		{
			for (String elem : this.getToolClasses(stack))
			{
				if (block.isToolEffective(elem, state))
				{
					return this.efficiencyOnProperMaterial;
				}
				else
				{
					Material mat = block.func_149688_o();
					for (Material m : MaterialHelper.getMaterialForTool(elem))
					{
						if (m == mat)
						{
							return this.efficiencyOnProperMaterial;
						}
					}
				}
			}
		}

		return 1.0F;
	}

	@Override
	public boolean canHarvestBlock(Block block, ItemStack stack)
	{
		return this.getDigSpeed(stack, block.func_176194_O().func_177621_b()) > 1.0f;
	}

	@Override
	public boolean func_77644_a(ItemStack itemstack, EntityLivingBase living1, EntityLivingBase living2)
	{
		if (this instanceof BaseSword)
		{
			itemstack.func_77972_a(1, living2);
		}
		else
		{
			itemstack.func_77972_a(2, living2);
		}

		return true;
	}

	@Override
	public int func_77619_b()
	{
		return this.toolMaterial.func_77995_e();
	}

	@Override
	public boolean func_179218_a(ItemStack stack, World world, Block block, BlockPos pos, EntityLivingBase player)
	{
		stack.func_77972_a(1, player);
		return true;
	}

	@SuppressWarnings("all")
	@Override
	public void func_77624_a(ItemStack itemStack, EntityPlayer entityPlayer, List list, boolean bool)
	{
		if (!(this instanceof BaseSword))
		{
			list.add("Efficiency: " + this.toolMaterial.func_77998_b());
		}
	}

	protected void changeToolDamage(ItemStack itemStack, double damage)
	{
		ItemStackUtils.addModifier(itemStack, SharedMonsterAttributes.field_111264_e.func_111108_a(), damage, 0);
	}

	/*
	 * TODO: What this do
	 * 
	 * @SuppressWarnings("all")
	 * 
	 * @Override public Multimap getAttributeModifiers(ItemStack stack) {
	 * Multimap multimap = super.getAttributeModifiers(stack);
	 * multimap.put(SharedMonsterAttributes.attackDamage.
	 * getAttributeUnlocalizedName(), new AttributeModifier(field_111210_e,
	 * "Tool modifier", this.damageVsEntity, 0)); return multimap; }
	 */
}
